
#include <stdio.h>

// prints a string, indented by some number of spaces (implemented below)
void print(char* spaceStart, char* spaceEnd, char* toPrint); 

// swap two bytes (implemented below)
void swap(char* a, char* b); 



// finds permutations of a substring
void permute(char* str, char* left, char* right) {
  if (left == right) {   // if we have gone all the way down a string,
    print(str,left,str); // print result!

  } else {                // if there's still work to do, 
    print(str,left,left); // print substring we're working on, and

    // then, for each character in the string
    for(char* current = left; current < right; current++) {
      swap(left, current);         // swap first byte with current
      permute(str, left+1, right); // recurse on rest of string
      swap(left, current);         // undo swap
    }

  }
}







// prints a string, indented by some number of spaces
void print(char* spaceStart, char* spaceEnd, char* stringToPrint) {
  for(printf("\n") ; spaceStart < spaceEnd; spaceStart++)
    printf(" "); 
  printf("%s\t",stringToPrint);
}

// swap two bytes
void swap(char* a, char* b) {
  printf(" %c <-> %c, ",*a,*b);
  char c = *a;     
  *a     = *b;         
  *b     = c;
}

// find end of a string
char* findEnd(char* str) {
  while (*str) // while we're not at the null byte at the end,
    str++;     // move the pointer right one character.
  return str;  // return pointer to null byte at end.
}

int main() {

  char str1[] = "ab";
  permute(str1, str1, findEnd(str1));
  printf("\n");

  char str2[] = "abc";
  permute(str2, str2, findEnd(str2));
  printf("\n");

  printf("\n");
  return 0;
}
